(*C*
      Embedding UNITY into the Calculus of Inductive Constructions
                                     Using the COQ Proof Assistent
      Author:  Mark-Oliver Stehr
               University of Hamburg
               Department of Computer Science
               Theoretical Foundations of Computer Science Group 
               stehr@informatik.uni-hamburg.de
      Date:    September 1998
*C*)



Theorem u_co_union : (pr,pr':u_prog)(p,q:u_prop)
  (u_co pr p q) -> (u_co pr' p q) -> 
  (u_co (u_prog_union pr pr') p q).

Intros.
Apply u_sc_co.
Intros.
Generalize (u_nc_co pr p q H).
Intros.
Generalize (u_nc_co pr' p q H0).
Intros.
Generalize (u_prog_union_spec pr pr' t).
Intros.
Elim H5.
Intros.
Generalize (H7 H1).
Intros.
Elim H8.
Intros.
Apply H3.
Assumption.
Assumption.
Intro.
Apply H4.
Assumption.
Assumption.
Qed.

Theorem u_stable_union : (pr,pr':u_prog)(p:u_prop)
  (u_stable pr p) -> (u_stable pr' p) -> 
  (u_stable (u_prog_union pr pr') p).

Unfold u_stable.
Intros.
Apply u_co_union.
Trivial.
Trivial.
Qed.

Theorem u_indinv_stable_union : (pr,pr':u_prog)(initially:u_prop)(p:u_prop)
  (u_ind_invariant pr initially p) -> (u_stable pr' p) -> 
  (u_ind_invariant (u_prog_union pr pr') initially p).

Unfold u_ind_invariant.
Intros.
Elim H.
Clear H.
Intros.
Split.
Trivial.
Apply u_stable_union.
Trivial.
Trivial.
Qed.

Theorem u_stable_indinv_union : (pr,pr':u_prog)(initially:u_prop)(p:u_prop)
  (u_stable pr' p) -> (u_ind_invariant pr initially p) -> 
  (u_ind_invariant (u_prog_union pr pr') initially p).

Unfold u_ind_invariant.
Intros.
Elim H0.
Clear H0.
Intros.
Split.
Trivial.
Apply u_stable_union.
Trivial.
Trivial.
Qed.

Theorem u_unless_union : (pr,pr':u_prog)(p,q:u_prop)
  (u_unless pr p q) -> (u_unless pr' p q) -> 
  (u_unless (u_prog_union pr pr') p q).

Unfold u_unless.
Intros.
Apply u_co_union.
Trivial.
Trivial.
Qed.

Theorem u_unless_stable_union : (pr,pr':u_prog)(p,q:u_prop)
  (u_unless pr p q) -> (u_stable pr' p) -> 
  (u_unless (u_prog_union pr pr') p q).

Intros.
Apply u_unless_union.
Trivial.
Apply u_stable_imp_unless.
Trivial.
Qed.

Theorem u_transient_union : (pr,pr':u_prog)(p:u_prop)
  ((u_transient pr p) \/ (u_transient pr' p)) ->
  (u_transient (u_prog_union pr pr') p).

Unfold u_transient.
Intros.
Elim H.
Clear H.
Intros.
Elim H.
Clear H.
Intros.
Elim H.
Clear H.
Intros.
Split with x.
Split.
Apply u_prog_union_spec_1.
Left .
Trivial.
Trivial.
Clear H.
Intros.
Elim H.
Clear H.
Intros.
Elim H.
Clear H.
Intros.
Split with x.
Split.
Apply u_prog_union_spec_1.
Right .
Trivial.
Trivial.
Qed.

Theorem u_transient_union_l : (pr,pr':u_prog)(p:u_prop)
  (u_transient pr p) ->
  (u_transient (u_prog_union pr pr') p).

Intros.
Apply u_transient_union.
Left .
Trivial.
Qed.

Theorem u_transient_union_r : (pr,pr':u_prog)(p:u_prop)
  (u_transient pr' p) ->
  (u_transient (u_prog_union pr pr') p).

Intros.
Apply u_transient_union.
Right .
Trivial.
Qed.

Theorem u_ensures_unless_union : (pr,pr':u_prog)(p,q:u_prop)
  (u_ensures pr p q) -> (u_unless pr' p q) -> 
  (u_ensures (u_prog_union pr pr') p q).

Unfold u_ensures.
Intros.
Elim H.
Intros.
Split.
Apply u_unless_union.
Trivial.
Trivial.
Apply u_transient_union.
Left .
Trivial.
Qed.

Theorem u_unless_ensures_union : (pr,pr':u_prog)(p,q:u_prop)
  (u_unless pr p q) -> (u_ensures pr' p q) -> 
  (u_ensures (u_prog_union pr pr') p q).

Unfold u_ensures.
Intros.
Elim H0.
Intros.
Split.
Apply u_unless_union.
Trivial.
Trivial.
Apply u_transient_union.
Right .
Trivial.
Qed.

Theorem u_ensures_stable_union : (pr,pr':u_prog)(p,q:u_prop)
  (u_ensures pr p q) -> (u_stable pr' p) -> 
  (u_ensures (u_prog_union pr pr') p q).

Intros.
Apply u_ensures_unless_union.
Trivial.
Apply u_stable_imp_unless.
Trivial.
Qed.

Theorem u_stable_ensures_union : (pr,pr':u_prog)(p,q:u_prop)
  (u_stable pr p) -> (u_ensures pr' p q) -> 
  (u_ensures (u_prog_union pr pr') p q).

Intros.
Apply u_unless_ensures_union.
Apply u_stable_imp_unless.
Trivial.
Trivial.
Qed.









